//[kaspresso](../../index.md)/[com.kaspersky.kaspresso.device.logcat](../index.md)/[LogcatImpl](index.md)



# LogcatImpl  
 [androidJvm] class [LogcatImpl](index.md)(**adbServer**: [AdbServer](../../com.kaspersky.kaspresso.device.server/-adb-server/index.md), **isNeededToPrintExecutedCommand**: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), **defaultBufferSize**: [LogcatBufferSize](../-logcat-buffer-size/index.md)) : [Logcat](../-logcat/index.md)   


## Types  
  
|  Name|  Summary| 
|---|---|
| [Companion](-companion/index.md)| [androidJvm]  <br>Content  <br>object [Companion](-companion/index.md)  <br><br><br>


## Functions  
  
|  Name|  Summary| 
|---|---|
| [clear](clear.md)| [androidJvm]  <br>Brief description  <br><br><br>Clear (flush) the selected buffers and exit. The default buffer set is main, system and crash.<br><br>  <br>Content  <br>open override fun [clear](clear.md)(buffer: [Logcat.Buffer](../-logcat/-buffer/index.md))  <br><br><br>
| [disableChatty](disable-chatty.md)| [androidJvm]  <br>Brief description  <br><br><br><br><br>NOT WORKING ON ANDROID 8+<br><br><br><br>The problem: Android OS has a special introduced mechanism to filter and collapse of some bunches of logs produced by applications. The name of the such mechanism is Chatty. Chatty turns on when an application writes a lot of logs. The goal of Logcat interface is to analyze all logs. But Chatty prevents achievement of the mentioned goal. That's why, there is this method to disable Chatty. Please, call the method in "before" section of a test.<br><br><br><br>  <br>Content  <br>open override fun [disableChatty](disable-chatty.md)()  <br><br><br>
| [equals](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/equals.html)| [androidJvm]  <br>Content  <br>open operator override fun [equals](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/equals.html)(other: [Any](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)?): [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)  <br><br><br>
| [hashCode](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/hash-code.html)| [androidJvm]  <br>Content  <br>open override fun [hashCode](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/hash-code.html)(): [Int](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)  <br><br><br>
| [readLogcatRows](read-logcat-rows.md)| [androidJvm]  <br>Brief description  <br><br><br>Get logcat dump as list of strings<br><br>  <br>Content  <br>open override fun [readLogcatRows](read-logcat-rows.md)(excludePattern: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)?, excludePatternIsIgnoreCase: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), includePattern: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)?, includePatternIsIgnoreCase: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), buffer: [Logcat.Buffer](../-logcat/-buffer/index.md), rowLimit: [Int](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)?): [List](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)<[String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)>  <br><br><br>[androidJvm]  <br>Brief description  <br><br><br>Get logcat dump and analyze each row. Logcat reading stops if analyzerBlock returns false on some row<br><br>  <br>Content  <br>open override fun [readLogcatRows](read-logcat-rows.md)(excludePattern: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)?, excludePatternIsIgnoreCase: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), includePattern: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)?, includePatternIsIgnoreCase: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), buffer: [Logcat.Buffer](../-logcat/-buffer/index.md), rowLimit: [Int](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)?, readingBlock: ([String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)) -> [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)): [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)  <br><br><br>
| [readLogcatRowsViaAdb](read-logcat-rows-via-adb.md)| [androidJvm]  <br>Brief description  <br><br><br><br><br>Required Permissions: READ_EXTERNAL_STORAGE. Required: Started AdbServer     1. Download a file "kaspresso/artifacts/adbserver-desktop.jar"     2. Start AdbServer => input in cmd "java jar path_to_file/adbserver-desktop.jar"<br><br><br><br>Get logcat dump via ADB and analyze each row. Logcat reading stops if analyzerBlock returns false on some row<br><br><br><br>Needed in cases when you want to check not only your application logs (with another PID). For example: if you need to check Firebase Analytics logs<br><br><br><br>  <br>Content  <br>fun [readLogcatRowsViaAdb](read-logcat-rows-via-adb.md)(excludePattern: [Regex](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)?, includePattern: [Regex](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)?, buffer: [Logcat.Buffer](../-logcat/-buffer/index.md), logcatFilePath: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html), readingBlock: ([String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)) -> [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)): [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)  <br><br><br>
| [setBufferSize](set-buffer-size.md)| [androidJvm]  <br>Brief description  <br><br><br>Set new logcat buffer size<br><br>  <br>Content  <br>open override fun [setBufferSize](set-buffer-size.md)(size: [LogcatBufferSize](../-logcat-buffer-size/index.md))  <br><br><br>
| [setDefaultBufferSize](set-default-buffer-size.md)| [androidJvm]  <br>Brief description  <br><br><br>Set default buffer size<br><br>  <br>Content  <br>open override fun [setDefaultBufferSize](set-default-buffer-size.md)()  <br><br><br>
| [toString](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/to-string.html)| [androidJvm]  <br>Content  <br>open override fun [toString](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/to-string.html)(): [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)  <br><br><br>

