//[kaspresso](../../index.md)/[com.kaspersky.kaspresso.testcases.core.testcontext](../index.md)/[TestContext](index.md)



# TestContext  
 [androidJvm] 

The special class to operate with in user scenario. Provides [step](step.md) and [scenario](scenario.md) methods in "run" section to build a test.

class [TestContext](index.md)<[Data](index.md)> : [BaseTestContext](../-base-test-context/index.md)   


## Parameters  
  
androidJvm  
  
|  Name|  Summary| 
|---|---|
| Data| <br><br>data created in before section.<br><br>
  


## Functions  
  
|  Name|  Summary| 
|---|---|
| [compose](../../com.kaspersky.kaspresso.compose/-compose-provider/compose.md)| [androidJvm]  <br>Brief description  <br><br><br>Composes a block of actions with their views to invoke on in one composite action that succeeds if at least one of it's parts succeeds. Please, be aware of or sections are executing flakySafely!<br><br>  <br>Content  <br>open override fun [compose](../../com.kaspersky.kaspresso.compose/-compose-provider/compose.md)(timeoutMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, intervalMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, allowedExceptions: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)<[Class](https://docs.oracle.com/javase/8/docs/api/java/lang/Class.html)<Out [Throwable](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-throwable/index.html)>>?, block: [ActionsOnElementsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-on-elements-pack/index.md).() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br><br><br>[androidJvm]  <br>Brief description  <br><br><br>Composes a block of actions on the given view of type Type in one composite action that succeeds if at least one of it's parts succeeds. Please, be aware of or sections are executing flakySafely!<br><br>  <br>Content  <br>open override fun <Type : BaseActions, BaseAssertions, Interceptable<ViewInteraction, ViewAssertion, ViewAction>> Type.[compose](../../com.kaspersky.kaspresso.compose/-compose-provider/compose.md)(timeoutMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, intervalMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, allowedExceptions: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)<[Class](https://docs.oracle.com/javase/8/docs/api/java/lang/Class.html)<Out [Throwable](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-throwable/index.html)>>?, block: [ActionsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-pack/index.md)<Type>.() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br>open override fun <Type : UiBaseActions, UiBaseAssertions, UiInterceptable<UiObjectInteraction, UiOperation<UiObject2>, UiOperation<UiObject2>>> Type.[compose](../../com.kaspersky.kaspresso.compose/-compose-provider/compose.md)(timeoutMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, intervalMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, allowedExceptions: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)<[Class](https://docs.oracle.com/javase/8/docs/api/java/lang/Class.html)<Out [Throwable](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-throwable/index.html)>>?, block: [ActionsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-pack/index.md)<Type>.() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br><br><br>[androidJvm]  <br>Brief description  <br><br><br>Composes a block of actions with their web views to invoke on in one composite action that succeeds if at least one of it's parts succeeds. Please, be aware of or sections are executing flakySafely!<br><br>  <br>Content  <br>open override fun WebElementBuilder.[compose](../../com.kaspersky.kaspresso.compose/-web-compose-provider/compose.md)(timeoutMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, intervalMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, allowedExceptions: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)<[Class](https://docs.oracle.com/javase/8/docs/api/java/lang/Class.html)<Out [Throwable](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-throwable/index.html)>>?, block: [ActionsOnWebElementsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-on-web-elements-pack/index.md).() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br>open override fun WebElementBuilder.KWebInteraction.[compose](../../com.kaspersky.kaspresso.compose/-web-compose-provider/compose.md)(webElementBuilder: WebElementBuilder, timeoutMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, intervalMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, allowedExceptions: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)<[Class](https://docs.oracle.com/javase/8/docs/api/java/lang/Class.html)<Out [Throwable](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-throwable/index.html)>>?, block: [ActionsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-pack/index.md)<WebElementBuilder.KWebInteraction>.() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br><br><br>
| [continuously](../../com.kaspersky.kaspresso.flakysafety/-continuously-provider/continuously.md)| [androidJvm]  <br>Brief description  <br><br><br><br><br>Invokes the given action during set timeout.<br><br><br><br>It can be helpful for checking of negative scenarios.<br><br><br><br>In opposite to FlakySafetyProvider.flakySafely it does not skip last attempt after first success and throws inside exception outside as soon as it was thrown<br><br><br><br>  <br>Content  <br>open override fun <T> [continuously](../../com.kaspersky.kaspresso.flakysafety/-continuously-provider/continuously.md)(action: () -> T): T  <br><br><br>[androidJvm]  <br>Brief description  <br><br><br><br><br>Invokes the given action during set timeout.<br><br><br><br>It can be helpful for checking of negative scenarios.<br><br><br><br>In opposite to FlakySafetyProvider.flakySafely it does not skips last attempt after first success and throws inside exception outside as soon as it was thrown<br><br><br><br>  <br>Content  <br>open override fun <T> [continuously](../../com.kaspersky.kaspresso.flakysafety/-continuously-provider/continuously.md)(timeoutMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, intervalMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, failureMessage: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)?, action: () -> T): T  <br><br><br>
| [equals](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/equals.html)| [androidJvm]  <br>Content  <br>open operator override fun [equals](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/equals.html)(other: [Any](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)?): [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)  <br><br><br>
| [flakySafely](../../com.kaspersky.kaspresso.flakysafety/-flaky-safety-provider/flaky-safely.md)| [androidJvm]  <br>Brief description  <br><br><br>Invokes the given action flaky safely.<br><br>  <br>Content  <br>open override fun <T> [flakySafely](../../com.kaspersky.kaspresso.flakysafety/-flaky-safety-provider/flaky-safely.md)(action: () -> T): T  <br>open override fun <T> [flakySafely](../../com.kaspersky.kaspresso.flakysafety/-flaky-safety-provider/flaky-safely.md)(timeoutMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, intervalMs: [Long](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)?, allowedExceptions: [Set](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)<[Class](https://docs.oracle.com/javase/8/docs/api/java/lang/Class.html)<Out [Throwable](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-throwable/index.html)>>?, failureMessage: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)?, action: () -> T): T  <br><br><br>
| [hashCode](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/hash-code.html)| [androidJvm]  <br>Content  <br>open override fun [hashCode](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/hash-code.html)(): [Int](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)  <br><br><br>
| [scenario](scenario.md)| [androidJvm]  <br>Brief description  <br><br><br>The representation of a composed [TestContext](index.md)'s steps.<br><br>  <br>Content  <br>fun [scenario](scenario.md)(scenario: [BaseScenario](../../com.kaspersky.kaspresso.testcases.api.scenario/-base-scenario/index.md)<[Data](index.md)>)  <br><br><br>
| [step](step.md)| [androidJvm]  <br>Brief description  <br><br><br>The representation of a [TestContext](index.md)'s step.<br><br>  <br>Content  <br>fun [step](step.md)(description: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html), actions: ([StepInfo](../../com.kaspersky.kaspresso.testcases.models.info/-step-info/index.md)) -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br><br><br>
| [toString](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/to-string.html)| [androidJvm]  <br>Content  <br>open override fun [toString](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/to-string.html)(): [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)  <br><br><br>
| [unsafeCompose](../../com.kaspersky.kaspresso.compose/-compose-provider/unsafe-compose.md)| [androidJvm]  <br>Brief description  <br><br><br>Composes a block of actions with their views to invoke on in one composite action that succeeds if at least one of it's parts succeeds. Please, be aware of or sections are executing without flakySafely mechanism     even though there may be flakySafely interceptors in your Kaspresso settings!<br><br>  <br>Content  <br>open override fun [unsafeCompose](../../com.kaspersky.kaspresso.compose/-compose-provider/unsafe-compose.md)(block: [ActionsOnElementsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-on-elements-pack/index.md).() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br>open override fun <Type : BaseActions, BaseAssertions, Interceptable<ViewInteraction, ViewAssertion, ViewAction>> Type.[unsafeCompose](../../com.kaspersky.kaspresso.compose/-compose-provider/unsafe-compose.md)(block: [ActionsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-pack/index.md)<Type>.() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br>open override fun <Type : UiBaseActions, UiBaseAssertions, UiInterceptable<UiObjectInteraction, UiOperation<UiObject2>, UiOperation<UiObject2>>> Type.[unsafeCompose](../../com.kaspersky.kaspresso.compose/-compose-provider/unsafe-compose.md)(block: [ActionsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-pack/index.md)<Type>.() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br><br><br>[androidJvm]  <br>Brief description  <br><br><br>Composes a block of actions with their web views to invoke on in one composite action that succeeds if at least one of it's parts succeeds. Please, be aware of or sections are executing without flakySafely mechanism     even though there may be flakySafely interceptors in your Kaspresso settings!<br><br>  <br>Content  <br>open override fun WebElementBuilder.[unsafeCompose](../../com.kaspersky.kaspresso.compose/-web-compose-provider/unsafe-compose.md)(block: [ActionsOnWebElementsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-on-web-elements-pack/index.md).() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br>open override fun WebElementBuilder.KWebInteraction.[unsafeCompose](../../com.kaspersky.kaspresso.compose/-web-compose-provider/unsafe-compose.md)(webElementBuilder: WebElementBuilder, block: [ActionsPack](../../com.kaspersky.kaspresso.compose.pack/-actions-pack/index.md)<WebElementBuilder.KWebInteraction>.() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html))  <br><br><br>


## Properties  
  
|  Name|  Summary| 
|---|---|
| [adbServer](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/adbServer/#/PointingToDeclaration/)|  [androidJvm] open override val [adbServer](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/adbServer/#/PointingToDeclaration/): [AdbServer](../../com.kaspersky.kaspresso.device.server/-adb-server/index.md)   <br>
| [data](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/data/#/PointingToDeclaration/)|  [androidJvm] val [data](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/data/#/PointingToDeclaration/): [Data](index.md)   <br>
| [device](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/device/#/PointingToDeclaration/)|  [androidJvm] open override val [device](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/device/#/PointingToDeclaration/): [Device](../../com.kaspersky.kaspresso.device/-device/index.md)   <br>
| [params](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/params/#/PointingToDeclaration/)|  [androidJvm] open override val [params](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/params/#/PointingToDeclaration/): [Params](../../com.kaspersky.kaspresso.params/-params/index.md)   <br>
| [testLogger](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/testLogger/#/PointingToDeclaration/)|  [androidJvm] open override val [testLogger](index.md#com.kaspersky.kaspresso.testcases.core.testcontext/TestContext/testLogger/#/PointingToDeclaration/): [UiTestLogger](../../com.kaspersky.kaspresso.logger/-ui-test-logger/index.md)   <br>

