//[kaspresso](../index.md)/[com.kaspersky.kaspresso.testcases.api.testcase](index.md)



# Package com.kaspersky.kaspresso.testcases.api.testcase  


## Types  
  
|  Name|  Summary| 
|---|---|
| [BaseTestCase](-base-test-case/index.md)| [androidJvm]  <br>Brief description  <br><br><br>The base class for all parametrized test cases. Extend this class with a single base project-wide inheritor of [TestCase](-test-case/index.md) as a parent for all actual project-wide test cases. Nesting test cases are not recommended, use [com.kaspersky.kaspresso.testcases.api.scenario.Scenario](../com.kaspersky.kaspresso.testcases.api.scenario/-scenario/index.md) instead.<br><br>  <br>Content  <br>abstract class [BaseTestCase](-base-test-case/index.md)<[InitData](-base-test-case/index.md), [Data](-base-test-case/index.md)>(**kaspressoBuilder**: [Kaspresso.Builder](../com.kaspersky.kaspresso.kaspresso/-kaspresso/-builder/index.md), **dataProducer**: ([InitData](-base-test-case/index.md).() -> [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)?) -> [Data](-base-test-case/index.md), **mainSectionEnrichers**: [List](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)<[MainSectionEnricher](../com.kaspersky.kaspresso.enricher/-main-section-enricher/index.md)<[Data](-base-test-case/index.md)>>) : [TestAssistantsProvider](../com.kaspersky.kaspresso.testcases.core.testassistants/-test-assistants-provider/index.md)  <br><br><br>
| [DocLocScreenshotTestCase](-doc-loc-screenshot-test-case/index.md)| [androidJvm]  <br>Brief description  <br><br><br><br><br>The base class for all docloc screenshot tests.<br><br><br><br>Project-wide ScreenshotTestCase should be implemented as following:<br><br>    open class ProductDocLocScreenshotTestCase(testName: String) : DocLocScreenshotTestCase(  <br>        File(testName), "comma-separated string of locales"  <br>    ) {  <br>  <br>        @get:Rule  <br>        val activityTestRule = ActivityTestRule(FragmentTestActivity::class.java, true, false)  <br>  <br>        protected lateinit var activity: FragmentTestActivity  <br>  <br>        @Before  <br>        open fun setUp() {  <br>            activity = activityTestRule.launchActivity(null)  <br>        }  <br>    }<br><br>Screenshoter test extends the project-wide class:<br><br>    @ScreenShooterTest  <br>    class FeatureScreenshot : ProductDocLocScreenshotTestCase("feature_screenshot") {  <br>  <br>        @Test  <br>        fun featureScreen() {  <br>            val featureView = FeatureFragment.newInstance()  <br>            activity.setFragment(featureView)  <br>            val view = getUiSafeProxy<FeatureView>(featureView) // Explicit type is important and must be interface  <br>  <br>            view.showLoading()  <br>            captureScreenshot("screenshot_description")  <br>        }  <br>    }<br><br>As you might have noticed, activity test rule is launched with ``FragmentTestActivity``. It's a special per-project empty activity for test with ``setFragment(Fragment)`` method. E.g:<br><br>    class FragmentTestActivity : AppCompatActivity() {  <br>  <br>        override fun onCreate(savedInstanceState: Bundle?) {  <br>            super.onCreate(savedInstanceState)  <br>            setContentView(R.layout.activity_fragment_container)  <br>        }  <br>  <br>        fun setFragment(fragment: Fragment) {  <br>            val fragmentTransaction = supportFragmentManager.beginTransaction()  <br>            fragmentTransaction.replace(R.id.content_container, fragment, "")  <br>            fragmentTransaction.build()  <br>        }  <br>    }<br><br>  <br>Content  <br>abstract class [DocLocScreenshotTestCase](-doc-loc-screenshot-test-case/index.md)(**screenshotsDirectory**: [File](https://docs.oracle.com/javase/8/docs/api/java/io/File.html), **screenshotDirectoryProvider**: [ScreenshotDirectoryProvider](../com.kaspersky.kaspresso.device.screenshots.screenshotfiles/-screenshot-directory-provider/index.md), **screenshotNameProvider**: [ScreenshotNameProvider](../com.kaspersky.kaspresso.device.screenshots.screenshotfiles/-screenshot-name-provider/index.md), **changeSystemLocale**: [Boolean](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html), **locales**: [String](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)?, **kaspressoBuilder**: [Kaspresso.Builder](../com.kaspersky.kaspresso.kaspresso/-kaspresso/-builder/index.md)) : [TestCase](-test-case/index.md)  <br><br><br>
| [TestCase](-test-case/index.md)| [androidJvm]  <br>Brief description  <br><br><br>The base class for all test cases. Extend this class with a single base project-wide inheritor of [TestCase](-test-case/index.md) as a parent for all actual project-wide test cases. Nesting test cases are not permitted because they may produce an exception caused by re-initialization of the [Kaspresso](../com.kaspersky.kaspresso.kaspresso/-kaspresso/index.md), use [com.kaspersky.kaspresso.testcases.api.scenario.Scenario](../com.kaspersky.kaspresso.testcases.api.scenario/-scenario/index.md) instead.<br><br>  <br>Content  <br>abstract class [TestCase](-test-case/index.md)(**kaspressoBuilder**: [Kaspresso.Builder](../com.kaspersky.kaspresso.kaspresso/-kaspresso/-builder/index.md)) : [BaseTestCase](-base-test-case/index.md)<[Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html), [Unit](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)>   <br><br><br>

